diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
index 4b483ea9f..d6577933a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
@@ -85,17 +85,20 @@ public class EntityFallingBlock extends Entity
     @Override
 	public void tick()
     {
-        if(this.carriedBlock.blockId == 0)
-        {
+        final boolean isClient = this.world.isClientSide;
+
+        if(this.carriedBlock.blockId == 0) {
             remove();
             return;
         }
+
         this.pushesThisTick = 0;
         this.pushTime *= 0.98f;
         if (this.pushTime < 0.05f || (this.pushTime < 0.25 && this.onGround)){
             this.pushTime = 0;
         }
-        if (isOnFire() && this.carriedBlock.blockId == Blocks.TNT.id()) {
+        
+        if (!isClient && this.carriedBlock.blockId == Blocks.TNT.id() && isOnFire()) {
             remove();
             EntityPrimedTNT entityPrimedTNT = new EntityPrimedTNT(this.world, this.x, this.y, this.z);
             entityPrimedTNT.xd = this.xd;
@@ -105,6 +108,7 @@ public class EntityFallingBlock extends Entity
             this.world.entityJoinedWorld(entityPrimedTNT);
             return;
         }
+
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
@@ -116,12 +120,16 @@ public class EntityFallingBlock extends Entity
         this.xd *= 0.98D;
         this.yd *= 0.98D;
         this.zd *= 0.98D;
-        TilePosc blockPos = roundedPos();
-        if(this.world.getBlockType(blockPos).id() == this.carriedBlock.blockId && !this.hasRemovedBlock)
-        {
+
+        final TilePosc blockPos = this.tilePosApprox();
+
+        // TODO tbh why are we using this hacky way of removing the block, should probably 
+        // TODO   just remove directly from within block logic :\
+        if (!isClient && this.world.getBlockType(blockPos).id() == this.carriedBlock.blockId && !this.hasRemovedBlock) {
             this.world.setBlockTypeNotify(blockPos, Blocks.AIR);
             this.hasRemovedBlock = true;
         }
+
         if (this.onGround) {
             Block<?> selfBlock = this.carriedBlock.block();
             Block<?> blockBelow = this.world.getBlockType(blockPos.down(new TilePos()));
@@ -140,53 +148,70 @@ public class EntityFallingBlock extends Entity
             this.pushTime *= (float) friction;
         }
 
-        double v = Math.hypot(this.xd, this.zd);
-        if (v < 0.001 || isInWall()) {
-            if(this.onGround || isInWall())
-            {
-                Entity rider = getPassenger();
-                ejectRider();
-                remove();
-                if(
-                    (
-                        this.fallChecker.canFallInto(this.world, this.carriedBlock, blockPos.down(new TilePos())) ||
-                        !this.world.setBlockType(blockPos, Blocks.getBlock(this.carriedBlock.blockId))
-                    ) && !this.world.isClientSide
-                ) {
-                    if(this.hasRemovedBlock) {
-                        drop();
-                    }
-                } else if (!this.world.isClientSide) {
-                    this.world.setBlockData(blockPos, this.carriedBlock.metadata);
-                    if (this.carriedBlock.entity != null) {
-                        TileEntity oldEnt = this.world.getTileEntity(blockPos);
-                        if (oldEnt != null) {
-                            oldEnt.invalidate();
-                        }
-                        this.carriedBlock.entity.validate();
-                        this.carriedBlock.entity.tilePos.x = blockPos.x();
-                        this.carriedBlock.entity.tilePos.y = blockPos.y();
-                        this.carriedBlock.entity.tilePos.z = blockPos.z();
-                        this.carriedBlock.entity.worldObj = this.world;
-                        this.carriedBlock.entity.carriedBlock = null;
-                        this.world.replaceTileEntity(blockPos, this.carriedBlock.entity);
-                    }
-                    this.world.notifyBlockChange(blockPos, Blocks.getBlock(this.carriedBlock.blockId));
+        if (!isClient) check_removal: {
+            final boolean isInWall = this.isInWall();
+            if (!isInWall) {
+                if (Math.hypot(this.xd, this.zd) >= 0x1p-4D) break check_removal;
+                if (!this.onGround) {
+                    if (this.fallTime <= 600) break check_removal;
+                    if (this.hasRemovedBlock) this.drop();
+                    this.ejectRider();
+                    this.remove();
+                    break check_removal;
                 }
-                if (rider != null) {
-                    TileEntity te = this.world.getTileEntity(blockPos);
-                    if (te instanceof IVehicle vehicle) rider.startRiding(vehicle);
+            }
+            final var passenger = getPassenger();
+            this.ejectRider();
+            this.remove();
+
+            // moving .hasRemovedBlock here fixes gravity block dupe
+            // note that it still creates duplicated falling block entity, but it cannot be
+            // turned into actual block (or item) anymore
+            if (this.hasRemovedBlock) fall_or_drop: {
+
+                // if can be placed at position, AND cannot replace position bellow (floored), try to place; 
+                // otherwise drop instead.
+                // 
+                // this causes the interesting behavior of falling block when falling onto 
+                // fence(gate) / boat, where they drop if the block above the fence, or the block
+                // the boat is in, is air, and place even if there's a torch above the fence / in the boat.
+                // 
+                // this should be changed if we want something more intuitive.
+                final boolean shoudPlaceHere = 
+                    !this.fallChecker.canFallInto(this.world, this.carriedBlock, blockPos.down(new TilePos()));
+
+                final boolean isPlaced = shoudPlaceHere &&
+                    this.world.setBlockType(blockPos, Blocks.getBlock(this.carriedBlock.blockId));
+
+                if (!isPlaced) {
+                    this.drop();
+                    break fall_or_drop;
                 }
-            } else if(this.fallTime > 600 && !this.world.isClientSide) {
-                if(this.hasRemovedBlock) {
-                    drop();
+
+                this.world.setBlockData(blockPos, this.carriedBlock.metadata);
+
+                final var tileEntity = this.carriedBlock.entity;
+                if (tileEntity != null) {
+                    tileEntity.validate();
+                    tileEntity.tilePos.set(blockPos);
+                    tileEntity.worldObj = this.world;
+                    tileEntity.carriedBlock = null;
+                    this.world.replaceTileEntity(blockPos, tileEntity);
+
+                    if (passenger != null && tileEntity instanceof IVehicle vehicle) {
+                        passenger.startRiding(vehicle);
+                    }
                 }
-                ejectRider();
-                remove();
+
+                this.world.notifyBlockChange(blockPos, this.carriedBlock.block());
             }
 
-            this.carriedBlock.heldTick(this.world, this);
+            // we used to call heldTick even after falling block is removed.
+            // was that _intended_?
+            return;
         }
+
+        this.carriedBlock.heldTick(this.world, this);
     }
 
     public void drop() {
@@ -199,10 +224,8 @@ public class EntityFallingBlock extends Entity
                 }
             }
         }
-        if (this.carriedBlock.entity != null) {
-            TilePosc blockPos = roundedPos();
-            this.carriedBlock.entity.dropContents(this.world, blockPos.x(), blockPos.y(), blockPos.z());
-        }
+        final var bpos = this.tilePosApprox();
+        if (this.carriedBlock.entity != null) this.carriedBlock.entity.dropContents(world, bpos.x(), bpos.y(), bpos.z());;
     }
 
     @Override
@@ -272,7 +295,7 @@ public class EntityFallingBlock extends Entity
         return 0.0D;
     }
 
-    public @NotNull TilePosc roundedPos() {
+    public @NotNull TilePosc tilePosApprox() {
         return new TilePos(MathHelper.round(this.x - 0.5), MathHelper.floor(this.y), MathHelper.round(this.z - 0.5));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java b/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
index 6cbeeb3fa..7913026e0 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
@@ -272,9 +272,9 @@ public class EntityPainting extends Entity {
                 break;
             }
         }
-        final double x = this.x + d.getOffsetX() / 4d;
-        final double y = this.y + d.getOffsetY() / 4d;
-        final double z = this.z + d.getOffsetZ() / 4d;
+        final double x = this.x + d.offsetX() / 4d;
+        final double y = this.y + d.offsetY() / 4d;
+        final double z = this.z + d.offsetZ() / 4d;
         this.world.entityJoinedWorld(new EntityItem(this.world, x, y, z, new ItemStack(Items.PAINTING)));
         if (getBorderStack() != null) {
             this.world.entityJoinedWorld(new EntityItem(this.world, x, y, z, getBorderStack()));
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 6b58551ce..6f73ebaa1 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -1195,9 +1195,9 @@ public abstract class Mob extends Entity {
             mode = this.placementModeOverride;
         }
         if (mode == PlacementMode.SIDE && side != null && side.isHorizontal()) {
-            return side.getDirection().getOpposite();
+            return side.direction().opposite();
         }
-        return Direction.getHorizontalDirection(this);
+        return Direction.getHorizontalLockable(this);
     }
 
     public @NotNull Direction getPlacementDirection(final @NotNull Side side) {
@@ -1212,9 +1212,9 @@ public abstract class Mob extends Entity {
             mode = this.placementModeOverride;
         }
         if (mode == PlacementMode.SIDE && side != null) {
-            return side.getDirection();
+            return side.direction();
         }
-        return Direction.getDirection(this);
+        return Direction.getLockable(this);
     }
 
     public Direction getVerticalPlacementDirection(Side side, double sideHeight) {
@@ -1230,7 +1230,7 @@ public abstract class Mob extends Entity {
         }
         if (mode == PlacementMode.SIDE) {
             if (side.isVertical()) {
-                return side.getDirection().getOpposite();
+                return side.direction().opposite();
             } else {
                 return sideHeight > 0.5 ? Direction.UP : Direction.DOWN;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
index 6eaeced84..94e8901d1 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
@@ -58,19 +58,19 @@ public class ProjectileCannonballBouncy extends ProjectileCannonball {
                     this.zd = 0f;
                     return;
                 }
-                if (side.getAxis() == Axis.Y) {
+                if (side.axis() == Axis.Y) {
                     this.yd = -this.yd * bounceAxisScale;
                     this.xd *= otherAxisScale;
                     this.zd *= otherAxisScale;
                     this.world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
                 }
-                if (side.getAxis() == Axis.X) {
+                if (side.axis() == Axis.X) {
                     this.xd = -this.xd * bounceAxisScale;
                     this.yd *= otherAxisScale;
                     this.zd *= otherAxisScale;
                     this.world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
                 }
-                if (side.getAxis() == Axis.Z) {
+                if (side.axis() == Axis.Z) {
                     this.zd = -this.zd * bounceAxisScale;
                     this.xd *= otherAxisScale;
                     this.yd *= otherAxisScale;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
index 23cdecf3c..4f8df4f8c 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
@@ -23,33 +23,34 @@ public class ItemBed extends Item {
         if (selfStack.stackSize <= 0) return false;
         TilePosc pos1 = blockPos;
         if (!world.canPlaceInsideBlock(pos1)) {
-            pos1 = new TilePos(pos1).add(side.getDirection());
+            pos1 = new TilePos(pos1).add(side.direction());
         }
-        Direction dir = player == null ? Direction.NORTH : player.getHorizontalPlacementDirection(null).getOpposite();
+        Direction dir = player == null ? Direction.NORTH : player.getHorizontalPlacementDirection(null).opposite();
         final TilePos pos2 = new TilePos(pos1).sub(dir);
         
         if (!world.canPlaceInsideBlock(pos1) || !world.canPlaceInsideBlock(pos2)) return false;
         
-        final TilePos qpos = new TilePos();
-        if (!world.canPlaceOnSurfaceOfBlock(qpos.set(pos1).down())) return false;
-        if (!world.canPlaceOnSurfaceOfBlock(qpos.set(pos2).down())) return false;
+        final var bed = Blocks.BED.getLogic();
+        if (!bed.isSupported(world, pos1, Side.BOTTOM)) return false;
+        if (!bed.isSupported(world, pos2, Side.BOTTOM)) return false;
         
         if (!world.canBlockIdBePlacedAt(Blocks.BED.id(), pos1, false, side)) return false;
-        // if (!world.canBlockIdBePlacedAt(Blocks.BED.id(), pos2, false, side)) return false;
+        if (!world.canBlockIdBePlacedAt(Blocks.BED.id(), pos2, false, side)) return false;
         
         
         final boolean isPlaced1 = 
-        world.setBlockTypeData(pos1, Blocks.BED, dir.getHorizontalIndex());
+        world.setBlockTypeData(pos1, Blocks.BED, dir.legacyHorizontalIndex());
         final boolean isPlaced2 = isPlaced1 &&
-        world.setBlockTypeData(pos2, Blocks.BED, dir.getHorizontalIndex() | BlockLogicBed.IS_HEAD.set(0, 1));
+        world.setBlockTypeData(pos2, Blocks.BED, dir.legacyHorizontalIndex() | BlockLogicBed.IS_HEAD.set(0, 1));
         if (!isPlaced2) {
             if (isPlaced1) world.setBlockType(pos1, Blocks.AIR);
             return false;
         }
         selfStack.consumeItem(player);
 
-        world.notifyBlockChange(pos1, Blocks.BED);
-        world.notifyBlockChange(pos2, Blocks.BED);
+        world.markBlockNeedsUpdate(pos1);
+        world.markBlockNeedsUpdate(pos2);
+        world.notifyBlocksInCapsuleOfNeighborChange(dir.opposite(), pos1, Blocks.BED);
 
         world.playBlockSoundEffect(player, pos1.x() + 0.5F, pos1.y() + 0.5F, pos1.z() + 0.5F, Blocks.BED, EnumBlockSoundEffectType.PLACE);
         return true;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java b/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
index 95329ef10..0d0fcfcc6 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
@@ -44,9 +44,9 @@ public class ItemBoat extends Item {
 
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        double x = blockPos.x() + offX + direction.getOffsetX();
-        double y = blockPos.y() + offY + direction.getOffsetY();
-        double z = blockPos.z() + offZ + direction.getOffsetZ();
+        double x = blockPos.x() + offX + direction.offsetX();
+        double y = blockPos.y() + offY + direction.offsetY();
+        double z = blockPos.z() + offZ + direction.offsetZ();
         selfStack.consumeItem(null);
         EntityBoat boat = new EntityBoat(world, x, y, z);
         world.entityJoinedWorld(boat);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
index 8d9bcfeb3..201bb20eb 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -248,9 +248,9 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
         Block<?> blockAtPos = world.getBlockType(rayCastPos);
         if (!blockAtPos.hasTag(BlockTags.PLACE_OVERWRITES) && !blockAtPos.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
             Side side = hitTile.side;
-            rayCastPos.x += side.getOffsetX();
-            rayCastPos.y += side.getOffsetY();
-            rayCastPos.z += side.getOffsetZ();
+            rayCastPos.x += side.offsetX();
+            rayCastPos.y += side.offsetY();
+            rayCastPos.z += side.offsetZ();
         }
 
         if (rayCastPos.y < 0 || rayCastPos.y >= world.getHeightBlocks()) return itemStack;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
index d6fb92c73..fc9c59284 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
@@ -33,22 +33,24 @@ public class ItemDoor extends Item {
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         if (player == null) return false;
         if (!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.getDirection(), new TilePos());
+            blockPos = blockPos.add(side.direction(), new TilePos());
         }
 
-        Direction leftDir = player.getHorizontalPlacementDirection(side).rotate(3);
-        int meta = leftDir.getHorizontalIndex();
+        if (!world.canBlockIdBePlacedAt(this.doorBlockBottom.id(), blockPos, false, side)) return false;
+
+        Direction leftDir = player.getHorizontalPlacementDirection(side).rotateY(1);
+        int meta = leftDir.legacyHorizontalIndex();
 
         int isSolidBlockLeft = (isSupported(world, blockPos, leftDir, false) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), leftDir, false) ? 1 : 0);
-        int isSolidBlockRight = (isSupported(world, blockPos, leftDir.getOpposite(), true) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), leftDir.getOpposite(), true) ? 1 : 0);
+        int isSolidBlockRight = (isSupported(world, blockPos, leftDir.opposite(), true) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), leftDir.opposite(), true) ? 1 : 0);
         boolean isDoorLeft = world.getBlockType(blockPos.add(leftDir, new TilePos())) == this.doorBlockBottom || world.getBlockType(blockPos.add(leftDir, new TilePos()).up(new TilePos())) == this.doorBlockTop;
         boolean isDoorRight = world.getBlockType(blockPos.sub(leftDir, new TilePos())) == this.doorBlockBottom || world.getBlockType(blockPos.sub(leftDir, new TilePos()).up(new TilePos())) == this.doorBlockTop;
         boolean isMirrored = false;
 
         if (isDoorLeft && !isDoorRight) {
             isMirrored = (world.getBlockData(blockPos.add(leftDir, new TilePos())) & BlockLogicDoor.MASK_HINGE) == 0;
-        } else if (isSolidBlockLeft <= 0 || side.getDirection() != leftDir.getOpposite()) {
-            if (isSolidBlockRight > 0 && side.getDirection() == leftDir) {
+        } else if (isSolidBlockLeft <= 0 || side.direction() != leftDir.opposite()) {
+            if (isSolidBlockRight > 0 && side.direction() == leftDir) {
                 isMirrored = true;
             } else if (isSolidBlockRight > isSolidBlockLeft) {
                 isMirrored = true;
@@ -72,16 +74,17 @@ public class ItemDoor extends Item {
         this.doorBlockBottom.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
         this.doorBlockTop.onPlacedByMob(world, blockPos.up(new TilePos()), side, player, xHit, yHit);
 
-        world.notifyBlockChange(blockPos, this.doorBlockBottom);
-        world.notifyBlockChange(blockPos.up(new TilePos()), this.doorBlockTop);
+        // this is technically incorrect as both positions are updated as bottom door,
+        // but does it really matter?
+        world.notifyBlocksInCapsuleOfNeighborChange(Direction.UP, blockPos, this.doorBlockBottom);
 
         world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
         return true;
     }
 
     public boolean isSupported(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction, boolean mirrored) {
-        ISupport support = world.getSupport(tilePos.add(direction, new TilePos()), direction.getSide().getOpposite());
-        return support.canSupport(mirrored ? PartialSupport.INSTANCE.right() : PartialSupport.INSTANCE.left(), direction.getSide());
+        ISupport support = world.getSupport(tilePos.add(direction, new TilePos()), direction.opposite().side());
+        return support.canSupport(mirrored ? PartialSupport.INSTANCE.right() : PartialSupport.INSTANCE.left(), direction.side());
     }
 
     @Override
@@ -91,18 +94,18 @@ public class ItemDoor extends Item {
         }
 
         if (!direction.isHorizontal()) direction = Direction.NORTH;
-        Direction lefDir = direction.rotate(3);
-        int meta = lefDir.getHorizontalIndex();
+        Direction lefDir = direction.rotateY(1);
+        int meta = lefDir.legacyHorizontalIndex();
 
         int isSolidBlockLeft = (isSupported(world, blockPos, lefDir, false) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), lefDir, false) ? 1 : 0);
-        int isSolidBlockRight = (isSupported(world, blockPos, lefDir.getOpposite(), true) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), lefDir.getOpposite(), true) ? 1 : 0);
+        int isSolidBlockRight = (isSupported(world, blockPos, lefDir.opposite(), true) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), lefDir.opposite(), true) ? 1 : 0);
         boolean isDoorLeft = world.getBlockType(blockPos.add(lefDir, new TilePos())) == this.doorBlockBottom || world.getBlockType(blockPos.add(lefDir, new TilePos()).up(new TilePos())) == this.doorBlockTop;
         boolean isDoorRight = world.getBlockType(blockPos.sub(lefDir, new TilePos())) == this.doorBlockBottom || world.getBlockType(blockPos.sub(lefDir, new TilePos()).up(new TilePos())) == this.doorBlockTop;
         boolean isMirrored = false;
 
         if (isDoorLeft && !isDoorRight) {
             isMirrored = (world.getBlockData(blockPos.add(lefDir, new TilePos())) & BlockLogicDoor.MASK_HINGE) == 0;
-        } else if (isSolidBlockLeft <= 0 || direction != lefDir.getOpposite()) {
+        } else if (isSolidBlockLeft <= 0 || direction != lefDir.opposite()) {
             if (isSolidBlockRight > 0 && direction == lefDir) {
                 isMirrored = true;
             } else if (isSolidBlockRight > isSolidBlockLeft) {
@@ -121,13 +124,15 @@ public class ItemDoor extends Item {
 
         world.setBlockTypeData(blockPos, this.doorBlockBottom, meta);
         world.setBlockTypeData(blockPos.up(new TilePos()), this.doorBlockTop, meta);
+        world.markBlockNeedsUpdate(blockPos);
+        world.markBlockNeedsUpdate(blockPos.up(new TilePos()));
+
         selfStack.consumeItem(null);
 
-        this.doorBlockBottom.onPlacedOnSide(world, blockPos, direction.getSide(), 0.5, 0.5);
-        this.doorBlockTop.onPlacedOnSide(world, blockPos.up(new TilePos()), direction.getSide(), 0.5, 0.5);
+        this.doorBlockBottom.onPlacedOnSide(world, blockPos, direction.side(), 0.5, 0.5);
+        this.doorBlockTop.onPlacedOnSide(world, blockPos.up(new TilePos()), direction.side(), 0.5, 0.5);
 
-        world.notifyBlockChange(blockPos, this.doorBlockBottom);
-        world.notifyBlockChange(blockPos.up(new TilePos()), this.doorBlockTop);
+        world.notifyBlocksInCapsuleOfNeighborChange(Direction.UP, blockPos, this.doorBlockBottom);
         
         world.playBlockSoundEffect(null, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
index 6a748984f..fd5015b4f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -142,7 +142,7 @@ public class ItemDye extends Item {
 
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        onUseOnBlock(selfStack, world, null, blockPos.add(direction, new TilePos()), direction.getSide(), 0.5, 0.5);
+        onUseOnBlock(selfStack, world, null, blockPos.add(direction, new TilePos()), direction.side(), 0.5, 0.5);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java b/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java
index 387d2b673..b4db79d49 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java
@@ -31,7 +31,7 @@ public class ItemEgg extends Item implements IDispensable {
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         ProjectileEgg projectileEgg = new ProjectileEgg(world, blockPos.x() + offX, blockPos.y() + offY, blockPos.z() + offZ);
-        projectileEgg.setHeading(direction.getOffsetX() * 0.6, direction.getOffsetY() == 0 ? 0.1 : direction.getOffsetY() * 0.6, direction.getOffsetZ() * 0.6f, 1.1F, 6F);
+        projectileEgg.setHeading(direction.offsetX() * 0.6, direction.offsetY() == 0 ? 0.1 : direction.offsetY() * 0.6, direction.offsetZ() * 0.6f, 1.1F, 6F);
         world.entityJoinedWorld(projectileEgg);
         selfStack.stackSize -= 1;
     }
@@ -40,7 +40,7 @@ public class ItemEgg extends Item implements IDispensable {
     public void onDispensed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Random random, @NotNull Direction direction, double x, double y, double z) {
         if (selfStack.consumeItem(null)) {
             ProjectileEgg projectileEgg = new ProjectileEgg(world, x, y, z);
-            projectileEgg.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
+            projectileEgg.setHeading(direction.offsetX(), direction.offsetY() + 0.1D, direction.offsetZ(), 1.1F, 6F);
             world.entityJoinedWorld(projectileEgg);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java b/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
index d4204c0b5..da56e8899 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
@@ -29,7 +29,7 @@ public class ItemFireStriker extends Item {
 
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        blockPos = blockPos.add(side.getDirection(), new TilePos());
+        blockPos = blockPos.add(side.direction(), new TilePos());
         if (world.isAirBlock(blockPos)) {
             if (world.setBlockTypeNotify(blockPos, Blocks.FIRE)) {
                 world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) blockPos.x() + 0.5D, (double) blockPos.y() + 0.5D, (double) blockPos.z() + 0.5D, "fire.ignite", 1.0F, itemRand.nextFloat() * 0.4F + 0.8F);
@@ -43,7 +43,7 @@ public class ItemFireStriker extends Item {
 
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        if (!onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5)) {
+        if (!onUseOnBlock(selfStack, world, null, blockPos, direction.side(), 0.5, 0.5)) {
             blockPos = blockPos.add(direction, new TilePos());
             TilePos queryPos = new TilePos();
             Block<?> b = world.getBlockType(blockPos);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
index c00177e8f..6dfaea5f8 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
@@ -57,7 +57,7 @@ public class ItemFlag extends Item {
         }
 
         if (!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.getDirection(), new TilePos());
+            blockPos = blockPos.add(side.direction(), new TilePos());
         }
         if (blockPos.y() < 0 || blockPos.y() >= world.getHeightBlocks()) {
             return false;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java b/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
index ffa78f320..bbb77458e 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
@@ -41,6 +41,6 @@ public class ItemMinecart extends Item {
 
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        onUseOnBlock(selfStack, world, null, blockPos.add(direction, new TilePos()), direction.getSide(), 0.5, 0.5);
+        onUseOnBlock(selfStack, world, null, blockPos.add(direction, new TilePos()), direction.side(), 0.5, 0.5);
     }
 }
